// rffwin2w.c RHS 2/25/89 rev. 8/21/91

#include<stdio.h>
#include<string.h>
#include<dos.h>
#include<errno.h>
#include<conio.h>
#include<stdlib.h>
#include<io.h>
#include<sys\types.h>
#include<sys\stat.h>

#if !defined(BOOL)
typedef int BOOL;
#endif

#if !defined(TRUE)
#define TRUE 1
#endif

#if !defined(FALSE)
#define FALSE 0
#endif

#define ALL_FILES    (_A_RDONLY | _A_HIDDEN | _A_SYSTEM | _A_ARCH)

#if defined(_WINDOWS)
#include<fcntl.h>
#define RFFVERSION 1.0
int currHdl;
char outbuf[120];
BOOL header = 0;
#define MAXHDLS 10
#endif

char Lastchar(char *str)
    {
    return (str[strlen(str)-1]);
    }

char *PLastchar(char *str)
    {
    return &str[strlen(str)-1];
    }


void rff(char *dirspec, char *filespec);
void main(int argc, char **argv);
void (*rffout)(char *dirspec,struct find_t *findbuf);
void printresults(char *dirspec, struct find_t *f);

void printresults(char *dirspec, struct find_t *f)
    {
#if !defined(_WINDOWS)
    static BOOL header;
#endif

    if(!header)
        {
#if !defined(_WINDOWS)
        printf(
#else
        sprintf(outbuf,
#endif
            "   Size     Attr    Date     Time     File         Path\n");
#if defined(_WINDOWS)
        write(currHdl,outbuf,strlen(outbuf));
#endif
        header = 1;
        }

#if !defined(_WINDOWS)
    printf(
#else
    sprintf(outbuf,
#endif
        "%10ld 0x%04x %02d/%02d/%02d %02d:%02d:%02d %12s %s\n",
        f->size,
        f->attrib,
        ((f->wr_date & 0x01ff) >> 5),
        f->wr_date & 0x001f,
        ((f->wr_date >> 9) + 80),
        (f->wr_time >> 11),
        ((f->wr_time >> 5) & 0x003f),
        ((f->wr_time & 0x001f) << 1),
        strlwr(f->name),
        strlwr(dirspec)
        );
#if defined(_WINDOWS)
    write(currHdl,outbuf,strlen(outbuf));
    _wyield();
#endif

    }

void rff(char *dirspec, char *filespec)
    {
    char *q, *r, old;
    int done;

    struct find_t findbuf;

    r = PLastchar(dirspec);                     // save address of
    r++;                                        // NULL at end of dirspec

    if(Lastchar(dirspec) != '\\')               // if no trailing backslash
        strcat(dirspec,"\\");                   // add trailing backslash
    q = PLastchar(dirspec);
    q++;                                        // set pointer to end
    strcat(dirspec,filespec);                   // add filespec to dirspec

    done = _dos_findfirst(dirspec,ALL_FILES,&findbuf);// find only files
    while(!done)
        {
        old = *q;                               // save off character @ q
        *q = '\0';                              // stuff in a NULL
        rffout(dirspec,&findbuf);
        *q = old;                               // restore character @ q
        done = _dos_findnext(&findbuf);              // get next filename
        }

    strcpy(q,"*.*");                            // work through sub-dirs

    done = _dos_findfirst(dirspec,_A_SUBDIR,&findbuf);// find subdirectories
    while(!done)
        {
        if(findbuf.name[0] != '.' && (findbuf.attrib & _A_SUBDIR))
            {
            strcpy(q,findbuf.name);          // set up with sub-dir name
            rff(dirspec,filespec);              // recurse into sub-dir
            strcpy(q,"*.*");                    // restore dirspec
            }
        done = _dos_findnext(&findbuf);
        }
    *r = '\0';                                  // restore to original state
    }


void main(int argc, char **argv)
    {
    char *p, dirspec[80], filespec[13];

#if defined(_WINDOWS)
    char *argptrs[2], tempdir[80], tempfile[13], versionstr[100];
    struct _wopeninfo win;
    int handles[MAXHDLS],i = -1;

    memset(handles,-1,sizeof(handles));
    sprintf(versionstr,"Recursive File Finder for Windows, v.%1.2f\n     By Richard Hale Shaw",RFFVERSION);
    _wabout(versionstr);
    _wsetexit(_WINEXITNOPERSIST);

    while(TRUE)
        {
        win._version = _WINVER;
        win._wbufsize = _WINBUFDEF;

        printf("Enter starting directory: ");
        if(!strlen(gets(tempdir)))
            {
            int focus = _wgetfocus();
            _wclose(focus,_WINNOPERSIST);
            return;
            }
        printf("Enter filespec: ");
        if(!strlen(gets(tempfile)))
            return;
        if(Lastchar(tempdir) != '\\')
            strcat(tempdir,"\\");
        strcat(tempdir,tempfile);

        win._title = strupr(tempdir);
        i++;
        if(i == MAXHDLS)
            i = 0;
        if(handles[i] != -1)
            _wclose(handles[i],_WINNOPERSIST);
        currHdl = handles[i] = _wopen(&win,NULL,O_WRONLY);
        _wsetscreenbuf(handles[i],_WINBUFINF);
        _wsetfocus(handles[i]);

        argv = argptrs;
        argc = 2;
        argptrs[0] = NULL;
        argptrs[1] = tempdir;
        header = 0;
#endif

    if(argc != 2)
        puts("Usage: rff <startdir><filespec>  ex: rff \\dos\\rff.exe\n");

    rffout = printresults;

    if((p = strrchr(argv[1],'\\')) || (p = strrchr(argv[1],':')))
        {
        p++;
        strcpy(filespec,p);
        *p = '\0';
        strcpy(dirspec,argv[1]);
        }
    else
        {
        strcpy(dirspec,".\\");
        strcpy(filespec,argv[1]);
        }
    rff(dirspec, filespec);
#if defined(_WINDOWS)
        }
#endif
    }

    // end of rffwin2.c





